
#include<stdio.h>
#include"ff.h"
#include"diskio.h"
#include"os816.h"


void *heap_start = (void *)0x7a000;
void *heap_end = (void *)0x7ffff;

#define eaddress ((volatile DWORD *)0x000329)
#define string ((UCHAR *)0x000200)


unsigned int far drives[8];
UINT far curDrive=255;
unsigned char far curPath[100]="1:/\0";
unsigned char far fn[100]="1:/\0";
DIR far dj;
FILINFO far fno;
FATFS far fs;
FIL far fp;
FIL far auxfp;


main()
{	
	int processed=0;	

	qputs("\n\rOS816 V0.1 for the SBC65816\n\r\0");
	qputs("D. Werner 10/18/2017\n\r\0");
	CMOSDrive();

	clear_all_locks(); // Clear File Locks

	curPath[0]=curDrive+'0';
	f_mount(curDrive,&fs);
	f_chdrive(curDrive);
	f_chdir(curPath);					


	for(;;)
	{	  
	  qputs(curPath);
	  qputs(">\0");
	  readstring(string);
	  qputs("\n\r\0");
	  processed=0;

	  if(Ustrncmp(string,"DIR\0",4))
	  {
		dir(&fs,"");
		processed++;
	  }

	  if(Ustrncmp(string,"DIR ",4))
	  {

		dir(&fs,string+4);
		processed++;
	  }

	  if(Ustrncmp(string,"TYPE ",5))
	  {
		type();
		processed++;
	  }


	  if(Ustrncmp(string,"MONITOR",7))
	  {
	  	asm 
	  	{
	  		BRK;
	  	}
	  }

 		
 	  if(Ustrncmp(string,"CD ",3))
	  {
		chdir();
		processed++;
	  }

	  if(Ustrncmp(string,"MD ",3))
	  {
		mkdir();
		processed++;
	  }

	  if(Ustrncmp(string,"DEL ",4))
	  {
		erase();
		processed++;
	  }

	  if(Ustrncmp(string,"REN ",4))
	  {
		ren();
		processed++;
	  }

	  if(Ustrncmp(string,"COPY ",5))
	  {
		cpy();
		processed++;
	  }

	  if((string[1]==':') && (string[2]==0))
	  {	  	
	  	f_chdrive(string[0]-'0');
	  	f_getcwd(curPath, 100);	  	
	  	processed++;
	  }

	  if(processed==0)
	  {
	  	runcommand();
	  }


	}
}



void dir(FATFS far *ffs,const char *path)
{	
	DWORD fre_clust, fre_sect, tot_sect;
	int result;
	result=0;
	
 	result=f_opendir(&dj,path);	 	
 	if(result!=0) 
	{
 		prtError(result);
	}
	else
	{	
	qprintf("Disk Label is %s\n\rDisk Serial Number is %lu\n\r\n\rDirectory of %s\n\r\n\r",ffs->vlabel,ffs->serno,curPath);

 	while(result==0)
 	{
		result=f_readdir(&dj,&fno);
		if(dj.sect==0)	break;	

		if( (fno.fattrib & 0x0e) == 0)
		{
		    qprintf("%02u/%02u/%02u %02u:%02u   ",(fno.fdate>>5)&0x0f,fno.fdate&0x1f,((fno.fdate>>9)&0x3f)+1980,(fno.ftime>>11)&0x1f,(fno.ftime>>5&0x3f));
		    if( (fno.fattrib & 0x10) == 0)
		    {
		    qprintf("%9lu  ",fno.fsize);
		    }
		    else
		    {
		    qputs("  <DIR>    \0");
		    }
		    qputs(fno.fname);
		    qputs("\n\r\0");		    			   
		}
	}

	f_getfree (curPath, &fre_clust, &ffs);

    	/* Get total sectors and free sectors */
    	tot_sect = (ffs->n_fatent - 2) * ffs->csize;
    	fre_sect = fre_clust * ffs->csize;

    	/* Print the free space (assuming 512 bytes/sector) */
    	qprintf("%10lu KB total drive space.\n\r%10lu KB available.\n\r\n\r", tot_sect / 2, fre_sect / 2);
	}
}

void type()
{	
	int result=0;
	unsigned int tmp=0;

	result=0;
	
 	result=f_open(&fp,string+5,FA_READ);

 	if(result!=0)
 	{
 	 prtError(result);
 	}
 	else
 	{
 		while(result==0)
 		{
	 		result=f_read (&fp,string,256,&tmp); 	
 			if(tmp==0) break;
			qputsn(string,tmp);
		}
 		qputs("\n\r\n\r\0");
 	}
 	f_close(&fp);
}


void runcommand()
{	
	int result=0;
	unsigned int tmp=0,x=0;
	unsigned char fname[13];
	BYTE *destination;
	BYTE *run;
	


	for(x=0;x<8;x++)
	{
		if((string[x]==' ')  || (string[x]==0) )
		{			
			break;
		}
		fname[x]=string[x];
	}

			fname[x]='.';
			fname[x+1]='8';
			fname[x+2]='1';
			fname[x+3]='6';
			fname[x+4]=0;

 	result=f_open(&fp,fname,FA_READ);

 	if(result!=0)
 	{
     	 	prtError(result);
 	}
 	else
 	{
		f_read (&fp,string,3,&tmp);
		if(Ustrncmp(string,"816",3))
		{
			f_read (&fp,&destination,4,&tmp);
			f_read (&fp,&run,4,&tmp);


 			while(result==0)
 			{
				result=f_read (&fp,destination,1024,&tmp); 	
 				if(tmp==0) break;
 				destination+=1024;				
			}

			eaddress[0]=(DWORD)run;

		asm {
			JMP [$0329];			
		}

		}
		else
		{
 			qputs("Not an executable command.\n\r\0");
		}
 	}
 	f_close(&fp);
}



void cpy()
{	
	int result;
	int result1;
	int x;
	unsigned int tmp=0,tmp1;

	for(x=5;x<128;x++)
	{
		if(string[x]==' ')  
		{
			string[x]=0;
			break;
		}
	}

	result=0;
	
 	result=f_open(&auxfp,string+x+1,FA_WRITE | FA_CREATE_ALWAYS);
 	if(result!=0)
 	{
 	 prtError(result);
 	 return;
 	}
 	result=f_open(&fp,string+5,FA_READ);
 	if(result!=0)
 	{
 	 prtError(result);
 	 return;
 	}

	result1=0;
	result=0;

	while((result==0) && (result1==0))
 		{
	 		result=f_read (&fp,(void *)0x020000,5120,&tmp); 	
	 		if(tmp==0) break;
	 		result1=f_write (&auxfp,(void *)0x020000,tmp,&tmp1); 	 			
		}
 	if(result!=0) prtError(result);
 	if(result1!=0) prtError(result1);

 	f_close(&fp);
 	f_close(&auxfp);
}



void chdir()
{	
	int Result=0;
 	Result=f_chdir(string+3); 	
 	if(Result!=0) prtError(Result); 	
 	curPath[0]=0;
 	f_getcwd(curPath, 100);
}

void mkdir()
{
	int Result=0;
 	Result=f_mkdir(string+3); 	
 	if(Result!=0) prtError(Result); 	
}

void erase()
{
	int Result=0;
 	Result=f_unlink(string+4); 	
 	if(Result!=0) prtError(Result); 	
}


void ren()
{
	int x;
	int Result=0;
	for(x=4;x<128;x++)
	{
		if(string[x]==' ')  
		{
			string[x]=0;
			break;
		}
	}

 	Result=f_rename(string+4,string+x+1); 	
 	if(Result!=0) prtError(Result); 	
}



void CMOSDrive()
{
	int x;

	for(x=0;x<8;x++)
		drives[x]=readRTC(33+x)&0x0f;

	for(x=0;x<8;x++)	
		if(drives[x]!=0)
		{
			curDrive=x;
			break;
		}
	


	qputs("\n\r-------------------------------------------------------\n\r");
	qputs("\n\rSYSTEM DRIVES:\n\r\0");	
	printFDriveLine("0: \0",drives[0]);	
	printFDriveLine("1: \0",drives[1]);	
	printFDriveLine("2: \0",drives[2]);	
	printFDriveLine("3: \0",drives[3]);	
	printIDriveLine("4: \0",drives[4]);	
	printIDriveLine("5: \0",drives[5]);	
	printSDriveLine("6: \0",drives[6]);	
	printSDriveLine("7: \0",drives[7]);	
	qputs("\n\r-------------------------------------------------------\n\r");
}

void printFDriveLine(unsigned char *y,int d)
{
	if(!d) return;
	qputs(y);	
	switch(d)
	{
		
		case 1:
			qputs("1.44MB\0");		
			break;
		case 2:
			qputs("720KB\0");		
			break;
		case 3:
			qputs("1.2MB\0");		
			break;
		case 4:
			qputs("360KB\0");		
			break;
	}
	qputs(" Floppy (CHS)\n\r\0");
}	

void printIDriveLine(unsigned char *y,int d)
{
	if(!d) return;
	qputs(y);	
	switch(d)
	{
		
		case 1:
			qputs("IDE\0");		
			break;
		case 2:
			qputs("ATAPI\0");		
			break;
	}
	qputs(" LBA\n\r\0");		

}	

void printSDriveLine(unsigned char *y,int d)
{
	if(!d) return;
	qputs(y);	
	qputs("SD LBA\n\r\0");		
}	


void prtError(int result)
{

	switch(result)
	{
		case 1:			/* (1) A hard error occured in the low level disk I/O layer */			
		case 2:			/* (2) Assertion failed */
		case 3:			/* (3) The physical drive cannot work */
			qputs("DISK ERROR.\n\r\0");
			break;
		case 4:			/* (4) Could not find the file */
			qputs("FILE NOT FOUND.\n\r\0");
			break;
		case 5:			/* (5) Could not find the path */
			qputs("PATH NOT FOUND.\n\r\0");
			break;
		case 6:			/* (6) The path name format is invalid */
			qputs("BAD FILE NAME.\n\r\0");
			break;
		case 7:			/* (7) Acces denied due to prohibited access or directory full */
		case 8:			/* (8) Acces denied due to prohibited access */
			qputs("ACCESS DENIED.\n\r\0");
			break;
		case 9:			/* (9) The file/directory object is invalid */
			qputs("INVALID FILE SYSTEM OBJECT.\n\r\0");
			break;
		case 10:		/* (10) The physical drive is write protected */
			qputs("DISK WRITE PROTECTED.\n\r\0");
			break;
		case 11:		/* (11) The logical drive number is invalid */
			qputs("INVALID DRIVE.\n\r\0");
			break;			
		case 18:		/* (18) Number of open files > _FS_SHARE */
			qputs("TOO MANY OPEN FILES.\n\r\0");
			break;
		case 19:		/* (19) Given parameter is invalid */
			qputs("INVALID PARAMETER.\n\r\0");
			break;
		default:
			qprintf("DOS ERROR. (%d)\n\r",result);
	}

	
}


