
#include<stdio.h>
#include"ff.h"
#include"os816.h"



/*-----------------------------------------------------------------------*/
/* OS816 API ACCESS				                         */
/*-----------------------------------------------------------------------*/
/*       					                         */
/*  FAR Call OSAPIVECTOR  ($XXXXXX)		                         */
/*  A REGISTER (WORD) = Function Number		                         */
/*  X REGISTER (WORD) = Address of Parameter Block                       */
/*       					                         */
/*-----------------------------------------------------------------------*/

#define function ((UINT *)0x000329)
#define paddress ((DWORD *)0x00032b)

/*----------------------------------------------------------------------*/
/* Mount/Unmount a logical drive 					*/	
typedef struct {
	BYTE 	vol;
	FATFS*	fs;	     /* Pointer to the owner file system object */
} S_API_MOUNT;

void API_MOUNT(void)
{	
	S_API_MOUNT *parm;	
	parm=(S_API_MOUNT *)paddress[0];

 	f_mount ( parm->vol, parm->fs);					
}
/*----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*/
/* Open or create a file 						*/
typedef struct {
	FIL *fp;		/* Pointer to the blank file object */
	TCHAR *path;		/* Pointer to the file name */
	BYTE mode;		/* Access mode and file open mode flags */
} S_API_OPEN;

void API_OPEN(void)
{	
	S_API_OPEN *parm;	
	parm=(S_API_OPEN *)paddress[0];

 	f_open (parm->fp,parm->path,parm->mode);						
}
/*----------------------------------------------------------------------*/



/*----------------------------------------------------------------------*/
/* Read data from a file 						*/
typedef struct {
	FIL *fp; 		/* Pointer to the file object */
	void *buff;		/* Pointer to data buffer */
	UINT btr;		/* Number of bytes to read */
	UINT *br;		/* Pointer to number of bytes read */
} S_API_READ;

void API_READ(void)
{	
	S_API_READ *parm;	
	parm=(S_API_READ *)paddress[0];

 	f_read(parm->fp,parm->buff,parm->btr,parm->br);			
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Move file pointer of a file object 					*/
typedef struct {
	FIL *fp;		/* Pointer to the file object */
	DWORD ofs;		/* File pointer from top of file */
} S_API_LSEEK;

void API_LSEEK(void)
{	
	S_API_LSEEK *parm;	
	parm=(S_API_LSEEK *)paddress[0];

 	f_lseek (parm->fp, parm->ofs);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Close an open file object 						*/
typedef struct {
	FIL *fp;		/* Pointer to the file object */
} S_API_CLOSE;

void API_CLOSE(void)
{	
	S_API_CLOSE *parm;	
	parm=(S_API_CLOSE *)paddress[0];

 	f_close (parm->fp);								
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Open an existing directory 						*/
typedef struct {
	DIR *dj;		/* Pointer to directory object to create */
	TCHAR *path;		/* Pointer to the directory path */
} S_API_OPENDIR;

void API_OPENDIR(void)
{	
	S_API_OPENDIR *parm;	
	parm=(S_API_OPENDIR *)paddress[0];

 	f_opendir (parm->dj,parm->path);	
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Read a directory item 						*/
typedef struct {
	DIR *dj;		/* Pointer to the open directory object */
	FILINFO *fno;		/* Pointer to file information to return */
} S_API_READDIR;

void API_READDIR(void)
{	
	S_API_READDIR *parm;	
	parm=(S_API_READDIR *)paddress[0];

 	f_readdir (parm->dj,parm->fno);	
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Get file status 							*/
typedef struct {
	TCHAR *path;			/* Pointer to the file path */
	FILINFO *fno;		/* Pointer to file information to return */
} S_API_STAT;

void API_STAT(void)
{	
	S_API_STAT *parm;	
	parm=(S_API_STAT *)paddress[0];

 	f_stat (parm->path,parm->fno);							
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Write data to a file 						*/
typedef struct {
	FIL *fp;		/* Pointer to the file object */
	void *buff;		/* Pointer to the data to be written */
	UINT btw;		/* Number of bytes to write */
	UINT *bw;		/* Pointer to number of bytes written */
} S_API_WRITE;

void API_WRITE(void)
{	
	S_API_WRITE *parm;	
	parm=(S_API_WRITE *)paddress[0];

 	f_write (parm->fp,parm->buff,parm->btw,parm->bw);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Get number of free clusters on the drive 				*/
typedef struct {
	TCHAR *path;	/* Pointer to the logical drive number (root dir) */
	DWORD *nclst;	/* Pointer to the variable to return number of free clusters */
	FATFS **fatfs;	/* Pointer to pointer to corresponding file system object to return */
} S_API_GETFREE;

void API_GETFREE(void)
{	
	S_API_GETFREE *parm;	
	parm=(S_API_GETFREE *)paddress[0];

 	f_getfree (parm->path,parm->nclst,parm->fatfs);	
}
/*----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*/
/* Truncate file 							*/
typedef struct {
	FIL *fp;		/* Pointer to the file object */
} S_API_TRUNCATE;

void API_TRUNCATE(void)
{	
	S_API_TRUNCATE *parm;	
	parm=(S_API_TRUNCATE *)paddress[0];

 	f_truncate (parm->fp);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Flush cached data of a writing file 					*/
typedef struct {
	FIL *fp;		/* Pointer to the file object */
} S_API_SYNC;

void API_SYNC(void)
{	
	S_API_SYNC *parm;	
	parm=(S_API_SYNC *)paddress[0];

 	f_sync (parm->fp);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Delete an existing file or directory 				*/
typedef struct {
	TCHAR *path;	/* Pointer to the file or directory path */
} S_API_UNLINK;

void API_UNLINK(void)
{	
	S_API_UNLINK *parm;	
	parm=(S_API_UNLINK *)paddress[0];

 	f_unlink (parm->path);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Make a directory							*/
typedef struct {
	TCHAR *path;	/* Pointer to the file or directory path */
} S_API_MKDIR;

void API_MKDIR(void)
{	
	S_API_MKDIR *parm;	
	parm=(S_API_MKDIR *)paddress[0];

 	f_mkdir (parm->path);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Change current directory						*/
typedef struct {
	TCHAR *path;	/* Pointer to the file or directory path */
} S_API_CHDIR;

void API_CHDIR(void)
{	
	S_API_CHDIR *parm;	
	parm=(S_API_CHDIR *)paddress[0];

 	f_chdir (parm->path);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Change attriburte of the file/dir 					*/
typedef struct {
	TCHAR *path;			/* Pointer to the file path */
	BYTE value;			/* Attribute bits */
	BYTE mask;			/* Attribute mask to change */
} S_API_CHMOD;

void API_CHMOD(void)
{	
	S_API_CHMOD *parm;	
	parm=(S_API_CHMOD *)paddress[0];

 	f_chmod (parm->path,parm->value,parm->mask);			
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Change timestamp of the file/dir 					*/
typedef struct {
	TCHAR *path;		/* Pointer to the file/directory name */
	FILINFO *fno;		/* Pointer to the time stamp to be set */
} S_API_UTIME;

void API_UTIME(void)
{	
	S_API_UTIME *parm;	
	parm=(S_API_UTIME *)paddress[0];

 	f_utime (parm->path,parm->fno);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Rename/Move a file or directory 					*/
typedef struct {
	TCHAR *path;		/* Pointer to the file/directory name */
	TCHAR *npath;		/* Pointer to the new file/directory name */
} S_API_RENAME;

void API_RENAME(void)
{	
	S_API_RENAME *parm;	
	parm=(S_API_RENAME *)paddress[0];

 	f_rename (parm->path,parm->npath);
}
/*----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*/
/* Change current drive 						*/
typedef struct {
	BYTE drive;		/* new current drive */
} S_API_CHDRIVE;

void API_CHDRIVE(void)
{	
	S_API_CHDRIVE *parm;	
	parm=(S_API_CHDRIVE *)paddress[0];

 	f_chdrive (parm->drive);
}
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Get current directory 						*/
typedef struct {
	TCHAR *path;		/* Pointer to the directory path */
	UINT sz_path;		/* Size of path */
} S_API_GETCWD;

void API_GETCWD(void)
{	
	S_API_GETCWD *parm;	
	parm=(S_API_GETCWD *)paddress[0];

	f_getcwd (parm->path,parm->sz_path);
}
/*----------------------------------------------------------------------*/



void API_DISPATCH()
{
	int f;
	f=function[0];

	switch(f)
	{
		case 100:
			API_MOUNT();
			break;
		case 101:
			API_OPEN();
			break;
		case 102:
			API_READ();
			break;
		case 103:
			API_LSEEK();
			break;
		case 104:
			API_CLOSE();
			break;
		case 105:
			API_OPENDIR();
			break;
		case 106:
			API_READDIR();
			break;
		case 107:
			API_STAT();
			break;
		case 108:
			API_WRITE();
			break;
		case 109:
			API_GETFREE();
			break;
		case 110:
			API_TRUNCATE();
			break;
		case 111:
			API_SYNC();
			break;
		case 112:
			API_UNLINK();
			break;
		case 113:
			API_MKDIR();
			break;
		case 114:
			API_CHDIR();
			break;
		case 115:
			API_CHMOD();
			break;
		case 116:
			API_UTIME();
			break;
		case 117:
			API_RENAME();
			break;
		case 118:
			API_CHDRIVE();
			break;
		case 119:
			API_GETCWD();
			break;
	}			
}


				
