
;__TESTAPI__________________________________________________________________________________________
;
;	TEST 65816 API INTERFACE THE RBC 65c816 SBC
;
;	WRITTEN BY: DAN WERNER -- 11/23/2017
;
;__________________________________________________________________________________________________
;
; DATA CONSTANTS
;__________________________________________________________________________________________________

		CHIP	65816		; SET CHIP		
		LONGA	OFF		; ASSUME EMULATION MODE			
		LONGI	OFF		;
		PW	128
		PL 	60
		INCLIST ON


;__________________________________________________________________________________________________
; $80A0-$80A3 FRONT PANEL 8255
;__________________________________________________________________________________________________

FPPORTA	  	 .EQU 	$FEA0
FPPORTB	    	 .EQU 	$FEA1
FPPORTC	    	 .EQU 	$FEA2
FPPIOCONT   	 .EQU 	$FEA3


; ZERO PAGE TEMP STUFF

IRQVECTADD   	.EQU   	$30   		; VECTOR FOR USER IRQ RTN       
WORKPTR		.EQU   	$32		; WORK POINTER FOR COMMAND PROCESSOR		
JUMPPTR		.EQU	$34		; JUMP VECTOR FOR LOOKUP TABLE	
TEMPWORD	.EQU	$36		;
TEMPWORD1	.EQU   	$38		;
TEMPWORD2	.EQU   	$3A		;
TEMPBYTE	.EQU	$3B		;
ACC      	.EQU   	$3D		; ACC STORAGE
XREG     	.EQU   	$3E 		; X REG STORAGE
YREG     	.EQU   	$3F 		; Y REG STORAGE
PREG     	.EQU   	$40 		; CURRENT STACK POINTER
PCL      	.EQU   	$41 		; PROGRAM COUNTER LOW
PCH      	.EQU   	$42 		; PROGRAM COUNTER HIGH
SPTR     	.EQU   	$43 		; CPU STATUS REGISTER
CKSM		.EQU	$44		; CHECKSUM
BYTECT		.EQU	$45		; BYTE COUNT
STRPTR	 	.EQU	$48		;
COUNTER	 	.EQU	$4A		;
SRC	 	.EQU	$4C		;
DEST	 	.EQU	$4E		;
COUNTER1 	.EQU	$50		;

INBUFFER	.EQU	$0200		;


; BIOS JUMP TABLE
PRINTVEC	.EQU $FFD0
INPVEC		.EQU $FFD3
INPWVEC		.EQU $FFD6




	.ORG	4000H

    .DB     "816"
    .DB     0Bh,40h,00h,00h
    .DB     0Bh,40h,00h,00h


        ;   ensure CPU Context is in a known state

        CLD                 ; VERIFY DECIMAL MODE IS OFF
        CLC                 ; 
        XCE                 ; SET NATIVE MODE
        SEP #$30            ; 8 bit registers (A AND I)
        LONGI off           ;
        LONGA OFF           ;
        LDA #$00            ;
        PHA                 ; Set Direct Register to 0
        PHA                 ; 
        PLD                 ;
        PHA                 ; set DBR to 0        
        PLB                 ;


        REP #$30            ; 16 bit registers (A AND I)
        LONGI ON            ;
        LONGA ON            ;


        LDA #100            ; CALL API_MOUNT
        STA $0329           ; STORE IT IN FUNCTION
        LDA #<S_API_MOUNT
        STA $032B           ; STORE DATA POINTER (low word)
        LDA #^S_API_MOUNT
        STA $032D           ; STORE DATA POINTER (high word)
        JSR $071004         ; DO API 

        jmp $071000         ; RETURN TO OS


;_DATA____________________________________________________________________________________________________________
; 
S_API_MOUNT:
	.DB	01                     ; VOLUME
	.DB	$56, $34,$12, 00	   ; ADDRESS OF FP BLOCK

.end


